## Madero Vale Presente Api

### Base URL Madero Api

| Tipo               | Url                                                  |
| ------------------ | ---------------------------------------------------- |
| Auth / Homologação | https://authsts-hml.grupomadero.com.br/connect/token |
| Hml / Homologação  | https://api-hml-giftcard.grupomadero.com.br/api/v1   |
| Auth / Produção    | https://authsts.grupomadero.com.br/connect/token     |
| Prd / Produção     | https://api-giftcard.grupomadero.com.br/api/v1       |

### Auth Madero

| Tipo              | Chave        | Token                                |
| ----------------- | ------------ | ------------------------------------ |
| Hml / Homologação | clientId     | client_giftcard_teknisa              |
| Hml / Homologação | clientSecret | 46e56ca3-686c-ef5d-d0a1-81e3aebf4718 |
| Hml / Homologação | username     | giftcard.teknisa                     |
| Hml / Homologação | password     | U#ImFkTtEcb4wo9                      |
| Prd / Produção    | clientId     | client_giftcard_teknisa              |
| Prd / Produção    | clientSecret | b78dd19b-6b44-1eb6-17ec-ac874d494f4a |
| Prd / Produção    | username     | giftcard.teknisa                     |
| Prd / Produção    | password     | Q*$8F<U{NOSpJx+qj*J5                 |

### Base URL API Teknisa

| Tipo                      | Url                                                                                              |
| ------------------------- | ------------------------------------------------------------------------------------------------ |
| Dev / Homologação Teknisa | https://heitorcarvalho2.zeedhi.com/workfolder/madero-vale-presente-api/backend/service/index.php |
| Hml / Homologação         | https://hml-todocartoes.grupomadero.com.br/index.php                                             |
| Prd / Produçao            | https://giftcard.grupomadero.com.br/index.php                                                    |

### Autenticação API Teknisa

| Tipo                      | Token                                                                            |
| ------------------------- | -------------------------------------------------------------------------------- |
| Dev / Homologação Teknisa | Bearer Tkecd66303GEjcdpe084UWdeo3gdcBW3803j3dHS902j783kJFUEw89xjwgbxw3hedK7312ls |
| Hml / Homologação         | Bearer Tkecd66303GEjcdpe084UWdeo3gdcBW3803j3dHS902j783kJFUEw89xjwgbxw3hedK7312ls |
| Prd / Produção            | Bearer Tkecd66303GEjcdpe084UWdeo3gdcBW3803j3dHS902j783kJFUEw89xjwgbxw3hedK7312ls |

### Rotas API Teknisa

<details>
  <summary>
    <code>POST</code>
    <code><b>/BalanceInquiry</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <address>172.158.1.38</address>
   <branchOffice>0356</branchOffice>
   <cards>
      <data>
         <cardNumber>5041616449381145</cardNumber>
      </data>
   </cards>
   <cashierCode>102</cashierCode>
   <channel>APP</channel>
   <requestId>3a559442-ee2a-4df7-b11b-b47c40d74528</requestId>
   <storeCode>001</storeCode>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
    <isSuccess>true</isSuccess>
    <value>
        <id>3a559442-ee2a-4df7-b11b-b47c40d74528</id>
    </value>
    <errors>null</errors>
    <error>false</error>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/BalanceInquiryResults</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <requestId>3a559442-ee2a-4df7-b11b-b47c40d74528</requestId>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
    <isSuccess>true</isSuccess>
    <value>
        <requestId>3a559442-ee2a-4df7-b11b-b47c40d74528</requestId>
        <branchOffice>0356</branchOffice>
        <cashierCode>102</cashierCode>
        <channel>APP</channel>
        <address>172.158.1.38</address>
        <storeCode>001</storeCode>
        <hasErrorCard>false</hasErrorCard>
        <cards>
            <data>
                <cardNumber>5041616449381145</cardNumber>
                <code>null</code>
                <requestId>5804dd9a-01df-4744-aa50-d9a8e4a20701</requestId>
                <success>true</success>
                <responseCode>200</responseCode>
                <responseMessage>Success</responseMessage>
                <messageCustomer>Sucesso</messageCustomer>
                <balance>
                    <value>97</value>
                    <currency>BRL</currency>
                </balance>
            </data>
        </cards>
    </value>
    <errors>null</errors>
    <error>false</error>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/PreRedemption</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <address>172.158.1.38</address>
   <branchOffice>0356</branchOffice>
   <cards>
      <data>
         <balanceInquiry>100</balanceInquiry>
         <cardNumber>5041616445809536</cardNumber>
         <cardPassword>850380</cardPassword>
         <expirationDate>2025-02-14T22:41:49.429Z</expirationDate>
      </data>
   </cards>
   <cashierCode>102</cashierCode>
   <channel>APP</channel>
   <consumer>
      <document>
         <type>CPF</type>
         <value>00507405048</value>
      </document>
      <email>marcos.santos@grupomadero.com.br</email>
      <name>Marcos Santos</name>
      <phone>
         <code>41</code>
         <country>55</country>
         <value>984110982</value>
      </phone>
   </consumer>
   <externalId>135987428</externalId>
   <items>
      <data>
         <name>Cheeseburger Madero Super</name>
         <price>
            <currency>BRL</currency>
            <value>1</value>
         </price>
         <quantity>1</quantity>
         <sku>0000053223</sku>
      </data>
   </items>
   <redeemedValue>1</redeemedValue>
   <requestId>563bb333-bcdc-4ec0-8e09-513c2f2ec2e5</requestId>
   <storeCode>001</storeCode>
   <totalPurchaseValue>1</totalPurchaseValue>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
    <isSuccess>true</isSuccess>
    <value>
        <id>563bb333-bcdc-4ec0-8e09-513c2f2ec2e5</id>
    </value>
    <errors>null</errors>
    <error>false</error>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/PreRedemptionResults</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <requestId>563bb333-bcdc-4ec0-8e09-513c2f2ec2e5</requestId>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
   <errors>null<errors>
   <isSuccess>true</isSuccess>
   <value>
      <address>172.158.1.38</address>
      <branchOffice>0356</branchOffice>
      <cards>
         <data>
            <cardNumber>5041616445809536</cardNumber>
            <messageCustomer>Sucesso</messageCustomer>
            <requestId>2ff1b433-2a84-4096-a837-9c3d7e4bca3e</requestId>
            <responseCode>200</responseCode>
            <responseMessage>Success</responseMessage>
            <success>true</success>
            <transactionDate>07/04/2024 15:35:49 +00:00</transactionDate>
         </data>
      </cards>
      <cashierCode>102</cashierCode>
      <channel>APP</channel>
      <consumer>
         <document>
            <type>CPF</type>
            <value>05489373970</value>
         </document>
         <email>marcos.santos@grupomadero.com.br</email>
         <name>Marcos Santos</name>
         <phone>
            <code>41</code>
            <country>55</country>
            <value>984110982</value>
         </phone>
      </consumer>
      <externalId>135987428</externalId>
      <items>
         <data>
            <name>Cheeseburger Madero Super</name>
            <price>
               <currency>BRL</currency>
               <value>1</value>
            </price>
            <quantity>1</quantity>
            <sku>0000053223</sku>
         </data>
      </items>
      <redeemedValue>50</redeemedValue>
      <requestId>563bb333-bcdc-4ec0-8e09-513c2f2ec2e5</requestId>
      <storeCode>001</storeCode>
      <totalPurchaseValue>50</totalPurchaseValue>
   </value>
   <error>false</error>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/BalanceInquiryPre</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <branchOffice>0356</branchOffice>
   <cards>
      <data>
         <cardNumber>5041610000000010</cardNumber>
         <cardPassword></cardPassword>
      </data>
   </cards>
   <cashierCode>102</cashierCode>
   <channel>APP</channel>
   <consumer>
      <document>
         <type>CPF</type>
         <value>123123123</value>
      </document>
      <email>test@example.com</email>
      <name>Joe</name>
      <phone>
         <code>51</code>
         <country>55</country>
         <value>123123123</value>
      </phone>
   </consumer>
   <externalId>999999</externalId>
   <ip>172.158.1.38</ip>
   <items>
      <data>
         <name></name>
         <price>
            <currency></currency>
            <value>0</value>
         </price>
         <quantity>0</quantity>
         <sku></sku>
      </data>
   </items>
   <requestId>f42f0e96-7496-4b0a-ac2d-ba61f7a32423</requestId>
   <storeCode>001</storeCode>
   <totalPurchaseValue>0</totalPurchaseValue>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
   <errors>null</errors>
   <isSuccess>true</isSuccess>
   <value>
      <requestId>f42f0e96-7496-4b0a-ac2d-ba61f7a32423</requestId>
   </value>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/BalanceInquiryPreResults</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <requestId>f42f0e96-7496-4b0a-ac2d-ba61f7a32423</requestId>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
   <errors>null</errors>
   <isSuccess>true</isSuccess>
   <value>
      <branchOffice>0356</branchOffice>
      <cards>
         <data>
            <balanceInquiry>0</balanceInquiry>
            <cardNumber>5041610000000010</cardNumber>
            <cardPassword></cardPassword>
            <expirationDate>2024-02-14T22:41:49.429Z</expirationDate>
            <responseCode>-200</responseCode>
            <responseMessage>Success</responseMessage>
            <responseMessageConsumer>Sucesso</responseMessageConsumer>
         </data>
      </cards>
      <cashierCode>102</cashierCode>
      <channel>APP</channel>
      <consumer>
         <document>
            <type>CPF</type>
            <value>123123123</value>
         </document>
         <email>test@example.com</email>
         <name>Joe</name>
         <phone>
            <code>51</code>
            <country>55</country>
            <value>123123123</value>
         </phone>
      </consumer>
      <externalId>999999</externalId>
      <ip>172.158.1.38</ip>
      <items>
         <data>
            <name></name>
            <price>
               <currency></currency>
               <value>0</value>
            </price>
            <quantity>0</quantity>
            <sku></sku>
         </data>
      </items>
      <redeemedValue>0</redeemedValue>
      <requestId>f42f0e96-7496-4b0a-ac2d-ba61f7a32423</requestId>
      <storeCode>001</storeCode>
      <totalPurchaseValue>0</totalPurchaseValue>
   </value>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/Redemption</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <address>172.158.1.38</address>
   <branchOffice>0356</branchOffice>
   <cards>
      <data>
         <balanceInquiry>100</balanceInquiry>
         <cardNumber>5041616445809536</cardNumber>
         <cardPassword>850380</cardPassword>
         <expirationDate>2025-02-14T22:41:49.429Z</expirationDate>
      </data>
   </cards>
   <cashierCode>102</cashierCode>
   <channel>APP</channel>
   <consumer>
      <document>
         <type>CPF</type>
         <value>05489373970</value>
      </document>
      <email>marcos.santos@grupomadero.com.br</email>
      <name>Marcos Santos</name>
      <phone>
         <code>41</code>
         <country>55</country>
         <value>984110982</value>
      </phone>
   </consumer>
   <externalId>135987428</externalId>
   <items>
      <data>
         <name>Cheeseburger Madero Super</name>
         <price>
            <currency>BRL</currency>
            <value>1</value>
         </price>
         <quantity>1</quantity>
         <sku>0000053223</sku>
      </data>
   </items>
   <redeemedValue>50</redeemedValue>
   <requestId>aae4200a-ee80-4ab5-95f7-be307f0051f9</requestId>
   <storeCode>001</storeCode>
   <totalPurchaseValue>50</totalPurchaseValue>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
    <isSuccess>true</isSuccess>
    <value>
        <id>aae4200a-ee80-4ab5-95f7-be307f0051f9</id>
    </value>
    <errors>null</errors>
    <error>false</error>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/RedemptionResults</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <requestId>aae4200a-ee80-4ab5-95f7-be307f0051f9</requestId>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
   <errors>null</errors>
   <isSuccess>true</isSuccess>
   <value>
      <address>172.158.1.38</address>
      <branchOffice>0356</branchOffice>
      <cards>
         <data>
            <cardNumber>5041616445809536</cardNumber>
            <messageCustomer>Sucesso</messageCustomer>
            <requestId>2ff1b433-2a84-4096-a837-9c3d7e4bca3e</requestId>
            <responseCode>200</responseCode>
            <responseMessage>Success</responseMessage>
            <success>true</success>
            <transactionDate>07/04/2024 15:35:49 +00:00</transactionDate>
         </data>
      </cards>
      <cashierCode>102</cashierCode>
      <channel>APP</channel>
      <consumer>
         <document>
            <type>CPF</type>
            <value>05489373970</value>
         </document>
         <email>marcos.santos@grupomadero.com.br</email>
         <name>Marcos Santos</name>
         <phone>
            <code>41</code>
            <country>55</country>
            <value>984110982</value>
         </phone>
      </consumer>
      <externalId>135987428</externalId>
      <items>
         <data>
            <name>Cheeseburger Madero Super</name>
            <price>
               <currency>BRL</currency>
               <value>1</value>
            </price>
            <quantity>1</quantity>
            <sku>0000053223</sku>
         </data>
      </items>
      <redeemedValue>50</redeemedValue>
      <requestId>aae4200a-ee80-4ab5-95f7-be307f0051f9</requestId>
      <storeCode>001</storeCode>
      <totalPurchaseValue>50</totalPurchaseValue>
   </value>
   <error>false</error>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/RedemptionConfirmation</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <address>172.158.1.38</address>
   <branchOffice>0356</branchOffice>
   <cards>
      <data>
         <cardNumber>5041610000000010</cardNumber>
      </data>
   </cards>
   <cashierCode>102</cashierCode>
   <channel>APP</channel>
   <externalId>999999</externalId>
   <requestId>aae4200a-ee80-4ab5-95f7-be307f0051f9</requestId>
   <storeCode>001</storeCode>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
    <isSuccess>true</isSuccess>
    <value>
        <id>aae4200a-ee80-4ab5-95f7-be307f0051f9</id>
    </value>
    <errors>null</errors>
    <error>false</error>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/RedemptionConfirmationResults</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <requestId>aae4200a-ee80-4ab5-95f7-be307f0051f9</requestId>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
   <errors>null</errors>
   <isSuccess>true</isSuccess>
   <value>
      <address>172.158.1.38</address>
      <branchOffice>0356</branchOffice>
      <cards>
         <data>
            <cardNumber>5041610000000010</cardNumber>
            <responseCode>200</responseCode>
            <responseMessage>Success.</responseMessage>
            <responseMessageConsumer>Sucesso.</responseMessageConsumer>
         </data>
      </cards>
      <cashierCode>102</cashierCode>
      <channel>APP</channel>
      <externalId>999999</externalId>
      <requestId>aae4200a-ee80-4ab5-95f7-be307f0051f9</requestId>
      <storeCode>001</storeCode>
   </value>
   <error>false</error>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/Cancel</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <address>172.158.1.38</address>
   <branchOffice>0356</branchOffice>
   <cashierCode>102</cashierCode>
   <channel>APP</channel>
   <externalId>135987428</externalId>
   <requestId>aae4200a-ee80-4ab5-95f7-be307f0051f9</requestId>
   <storeCode>001</storeCode>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
    <isSuccess>true</isSuccess>
    <value>
        <id>aae4200a-ee80-4ab5-95f7-be307f0051f9</id>
    </value>
    <errors>null</errors>
    <error>false</error>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/CancelResults</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <requestId>aae4200a-ee80-4ab5-95f7-be307f0051f9</requestId>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
   <errors>null</errors>
   <isSuccess>true</isSuccess>
   <value>
      <address>172.158.1.38</address>
      <branchOffice>0356</branchOffice>
      <cashierCode>102</cashierCode>
      <channel>APP</channel>
      <externalId>999999</externalId>
      <requestId>aae4200a-ee80-4ab5-95f7-be307f0051f9</requestId>
      <storeCode>001</storeCode>
   </value>
   <error>false</error>
</root>
```

</details>

---

<details>
  <summary>
    <code>POST</code>
    <code><b>/RegisterCard</b></code>
  </summary>

##### Payload

```
<?xml version="1.0"?>
<root>
   <address>172.158.1.38</address>
   <branchOffice>0356</branchOffice>
   <cardNumber>5041616449381145</cardNumber>
   <cardPassword>279151</cardPassword>
   <cashierCode>102</cashierCode>
   <channel>APP</channel>
   <storeCode>001</storeCode>
</root>
```

##### Response

```
<?xml version="1.0"?>
<root>
    <isSuccess>true</isSuccess>
    <value>
        <address>172.158.1.38</address>
        <branchOffice>0356</branchOffice>
        <cardNumber>5041616449381145</cardNumber>
        <cashierCode>102</cashierCode>
        <channel>APP</channel>
        <storeCode>001</storeCode>
        <success>true</success>
        <responseCode>200</responseCode>
        <responseMessage>Success</responseMessage>
        <messageCustomer>Sucesso</messageCustomer>
        <balance>
            <value>42</value>
            <currency>BRL</currency>
        </balance>
    </value>
    <errors>null</errors>
    <error>false</error>
</root>
```

</details>

---
